//-----------------------------------------------------------------------------
//
// VTASSERT helper file. 
//
// Include this file to have VTASSERT defined in all modules which
// don't require interacting with user unless compiled in debug mode.
//
// Be sure to include this file THE LAST so it won't redefine VTASSERT
// if it is defined by vt_messageboxes.hpp.
//
//-----------------------------------------------------------------------------

/*
	VT Framework License (BSL 1.0)

	Copyright (C) 2007 Sergey A. Galin 
	E-mail: sergey.galin@gmail.com

	Permission is hereby granted, free of charge, to any person or organization
	obtaining a copy of the software and accompanying documentation covered by
	this license (the "Software") to use, reproduce, display, distribute,
	execute, and transmit the Software, and to prepare derivative works of the
	Software, and to permit third-parties to whom the Software is furnished to
	do so, all subject to the following:

	The copyright notices in the Software and this entire statement, including
	the above license grant, this restriction and the following disclaimer,
	must be included in all copies of the Software, in whole or in part, and
	all derivative works of the Software, unless such copies or derivative
	works are solely in the form of machine-executable object code generated by
	a source language processor.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
	SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
	FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/

#ifndef VT_INSIDE_MESSAGEBOXES_H

#ifndef VT_ASSERT_H
#define VT_ASSERT_H

#if !defined(VTASSERT) 
	#if defined(_DEBUG)
		#ifdef VERBOSE
			#ifdef _MSC_VER
				#pragma message("Including messageboxes.h for VTASSERT definition.")
			#else
				#warning Including messageboxes.h for VTASSERT definition.
			#endif
		#endif
		#include "vt_messageboxes.hpp"
		#if !defined(VTASSERT) || !defined(VTASSERT2) || !defined(VTASSERT2T)
			#error "Something went wrong with VTASSERT, immediately after vt_messageboxes.hpp!!!"
		#endif

	#else
		#define VTASSERT(x)			{}
		#define VTASSERT2(x, msg)	{}
		#define VTASSERT2T(x, msg)	{}
		#define VTDEBUGMSG(x)		{}
		#define VTDEBUGMSGT(x)		{}
		#define VTDEBUGMSGBOX		{}
		#ifdef VERBOSE
			#ifdef _MSC_VER
				#pragma message("VTASSERT is defined as empty macro.")	
			#else
				#warning VTASSERT is defined as empty macro.
			#endif
		#endif
	#endif
#else
	#ifdef VERBOSE
		#ifdef _MSC_VER
			#pragma message("VTASSERT already defined.")	
		#else
			#warning VTASSERT already defined.
		#endif
	#endif
#endif

#endif

#if !defined(VTASSERT) || !defined(VTASSERT2) || !defined(VTASSERT2T)
	#error "Something went wrong with VTASSERT!!!"
#endif


#endif  /* #ifdef VT_INSIDE_MESSAGEBOXES_H */



