//-----------------------------------------------------------------------------
//
// Debug macros
//
//-----------------------------------------------------------------------------

/*
	VT Framework License (BSL 1.0)

	Copyright (C) 2006 Sergey A. Galin 
	E-mail: sergey.galin@gmail.com

	Permission is hereby granted, free of charge, to any person or organization
	obtaining a copy of the software and accompanying documentation covered by
	this license (the "Software") to use, reproduce, display, distribute,
	execute, and transmit the Software, and to prepare derivative works of the
	Software, and to permit third-parties to whom the Software is furnished to
	do so, all subject to the following:

	The copyright notices in the Software and this entire statement, including
	the above license grant, this restriction and the following disclaimer,
	must be included in all copies of the Software, in whole or in part, and
	all derivative works of the Software, unless such copies or derivative
	works are solely in the form of machine-executable object code generated by
	a source language processor.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
	SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
	FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/


#include "vt_debug.hpp"

#if !defined(VT_WINDOWS)
	#include <time.h>
#endif

using namespace VT;

void VT::DbgTimeStr( VTCHAR *out )
{
	#if defined(VT_WINDOWS)
    	// MSC, BORLANDC compatible
		SYSTEMTIME time;
		GetSystemTime( &time );
		VTSPRINTF( out, VTT("%d-%02d-%02d %2d:%02d:%02d.%03d"),
			int(time.wYear),
			int(time.wMonth), 
			int(time.wDay), 
			int(time.wHour), 
			int(time.wMinute), 
			int(time.wSecond), 
			int(time.wMilliseconds) );
	#else
		time_t t;
		time( &t );
		ctime_r( &t, out );
	#endif

}

LPCVTCHAR VT::DbgTimeStr()
{
	static VTCHAR buffer[128];
	VT::DbgTimeStr( buffer );
	return buffer;
}




